<CsoundSynthesizer>
<CsOptions>
-odac -Ma -b128 -B512 --midi-key=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>

/******PLUCKED STRING INSTEAD OF SINE WAVES******/

;;SCALES TO BE PLAYED
;Scale 1: Equal-tempered Half Tones (12 steps per octave)
giHalfTones	ftgen 		1, 0, -12, -2,  0, 100, 200, 300, 400, 500, 600, 700, 800, 900, 1000, 1100
;Scale 2: Third Tones (18 steps per octave)
giThirTones	ftgen 		2, 0, -18, -2,  0, 66.67, 133.33, 200, 266.67, 333.33, 400, 466.67, 533.33, 600, 666.67, 733.33, 800, 866.67, 933.33, 1000, 1066.67, 1133.33
;Scale 3: Quarter Tones (24 steps per octave)
giQuarTones 	ftgen 		3, 0, -24, -2,  0, 50, 100, 150, 200, 250, 300, 350, 400, 450, 500, 550, 600, 650, 700, 750, 800, 850, 900, 950, 1000, 1050, 1100, 1150
;Scale 4: Indian Sruti (22 steps per octave)
giSruti	ftgen		4, 0, -22, -2,  0, 90, 112, 182, 204, 294, 316, 386, 408, 498, 520, 490, 610, 702, 792, 814, 884, 906, 996, 1018, 1088, 1110

		massign 	0, 1

instr 1
;;INPUT
ikey		=		p4
ivel		=		p5
kreftone	invalue	"reftone"; any midi note number
ktunfreq	invalue	"tunfreq"; any frequency for it
kscale		invalue	"scale"; select scale by menu
ireftone	=		i(kreftone)
itunfreq	=		i(ktunfreq)
iscale		=		i(kscale) + 1; menu item 0 selects function table 1 etc
;;CALCULATION
itablen	=		ftlen(iscale)
ioct 		= 		floor((p4 - ireftone) / itablen);oktavlage
indx1 		= 		(p4-ireftone) % itablen; correct values > 0 but negative for < 0

indx 		= 		(indx1 < 0 ? itablen + indx1 : indx1); so instead of -1 we get 17 now
icent1 	tab_i 		indx, iscale; get the correct value from the centlist ...
icent 		= 		icent1 + (ioct * 1200); and modify it by the octave position
ifreq 		= 		itunfreq * cent(icent); get the frequency
anote		pluck		ivel, ifreq, ifreq, 0, 1
kenv		linsegr	1, 1, 1, .1, 0
		out		anote * kenv
;;SHOW OUTPUT
Skey		sprintf	"%d", ikey
		outvalue	"key", Skey; key pressed
Scale		sprintf	"%d", iscale
		outvalue	"table", Scale; ftable number of scale
Steps		sprintf	"%d", itablen
		outvalue	"steps", Steps; number of steps in the scale
Sindx		sprintf	"%d", indx
		outvalue	"indx", Sindx; which step is selected by this key
		outvalue	"cent", icent; cent difference in relation to the reference frequency
		outvalue	"freq", ifreq
endin
</CsInstruments>
<CsScore>
f 0 9999
e
</CsScore>
</CsoundSynthesizer>
<MacOptions>
Version: 3
Render: Real
Ask: Yes
Functions: ioObject
Listing: Window
WindowBounds: 734 147 370 427
CurrentView: io
IOViewEdit: On
Options:
</MacOptions>
<MacGUI>
ioView background {43433, 43947, 32896}
ioText {242, 179} {80, 25} display 0.000000 0.00100 "key" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 52
ioText {66, 179} {174, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Key Pressed
ioText {244, 270} {80, 25} display 0.000000 0.00100 "indx" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 7
ioText {-1684371923, -1632653318} {227, 25} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation
ioText {245, 239} {78, 26} display 0.000000 0.00100 "steps" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 12
ioText {13, 237} {225, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Number of Steps per Octave
ioText {246, 299} {78, 31} display 0.000000 0.00100 "cent" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder -1700.0000
ioText {14, 297} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Difference in Relation to the Reference Frequency
ioText {246, 347} {78, 31} display 0.000000 0.00100 "freq" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 164.8045
ioText {14, 345} {225, 45} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Frequency of this Key
ioText {5, 10} {351, 134} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {56832, 36608, 52736} nobackground border INPUT
ioText {12, 150} {315, 235} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground border OUTPUT
ioText {129, 104} {107, 26} editnum 440.000000 0.000001 "tunfreq" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 440.000000
ioText {121, 46} {123, 31} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Related Pitch
ioText {141, 73} {72, 27} label 0.000000 0.00100 "" center "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder (Hertz)
ioText {-610629723, -1632653302} {80, 25} display 0.000000 0.00100 "cent" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder -1700.0000
ioText {-610629955, -1632653304} {227, 25} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Cent Deviation
ioText {14, 268} {225, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Step selected by Key
ioText {241, 208} {80, 25} display 0.000000 0.00100 "table" left "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 1
ioText {65, 208} {174, 27} label 0.000000 0.00100 "" right "Lucida Grande" 12 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Selected Scale (Table)
ioMenu {244, 106} {101, 25} 0 303 "Halftones,Thirdtones,Quartertones,Sruti" scale
ioText {251, 46} {84, 49} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Select Scale
ioText {36, 108} {68, 26} editnum 69.000000 1.000000 "reftone" left "Lucida Grande" 8 {0, 0, 0} {65280, 65280, 65280} nobackground noborder 69.000000
ioText {21, 47} {90, 47} label 0.000000 0.00100 "" center "Lucida Grande" 16 {0, 0, 0} {65280, 65280, 65280} nobackground noborder Reference Tone
ioText {25, 87} {87, 25} label 0.000000 0.00100 "" center "Lucida Grande" 10 {0, 0, 0} {65280, 65280, 65280} nobackground noborder (Midi-Number)
</MacGUI>

